



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>variable-precision SWAR算法介绍</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">variable-precision SWAR算法介绍</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 09:39:44 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>BITCOUNT命令是统计一个位数组中非0进制位的数量，数学上称作：&rdquo;Hanmming Weight&ldquo;</p>
<p>目前效率最好的为variable-precision SWAR算法，可以常数时间内计算出多个字节的非0数目，算法设计的非常精巧，值得学习。</p>
<div>
<pre class="prettyprint linenums">int swar(uint32_t i)<br />
{<br />
    // (A)<br />
    i = ( i &amp; 0x55555555) + ((i &gt;&gt; ) &amp; 0x55555555);

    // (B)<br />
    i = (i &amp; 0x33333333) + ((i &gt;&gt; ) &amp; 0x33333333);

    // (C)<br />
    i = (i &amp; 0x0F0F0F0F) + ((i &gt;&gt; ) &amp; 0x0F0F0F0F);

    // (D)<br />
    i = (i * 0x01010101) &gt;&gt; );

    return i;<br />
}</pre>
</div>
<p>原理解释：</p>
<p>(A) 0x55555555 &nbsp;二进制为： &nbsp;0101 0101 0101 0101 &nbsp;0101 0101 0101 0101， 奇位为1， 偶数为0</p>
<p>　 如果按照i的二进制表示 &nbsp;b31 b30....... &nbsp;b7 b6 b5 b4 b3 b2 b1 b0</p>
<p>i &amp; 0x55555555 &nbsp;则取出全部的奇数位： &nbsp; &nbsp; &nbsp; &nbsp; 0 &nbsp;b30 ...... 0 &nbsp;b6 0 b4 0 b2 0 b0</p>
<p>(i &gt;&gt; 1) &amp; 0x55555555 则取出偶数位： &nbsp; &nbsp; &nbsp; &nbsp;0 b31 &nbsp; &nbsp; &nbsp; &nbsp;0 &nbsp;b7 &nbsp;0 b5 0 b3 0 b1</p>
<p>　　两者相加： &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;+ ------------------------------------------</p>
<p>0 &nbsp;(b30+b31) &nbsp; &nbsp; ..... &nbsp; &nbsp; &nbsp; &nbsp; 0 &nbsp; (b6+b7) &nbsp; 0 &nbsp; (b4+b5) &nbsp; 0 &nbsp; (b2+b3) &nbsp; &nbsp;0 &nbsp; （b0+b1）</p>
<p>原理就是按照二进制2位一个分割，计算该两位的1的数目</p>
<p>(B) 将 （A）步骤按照二进制2位划分的1的数目按照4个bit位进行累加</p>
<p>(C) 将 &nbsp;（B）步骤中1的数目按照8个bit位进行累加</p>
<p>(D) &nbsp;(C)步骤中已经计算出了8bit划分的2进制的数目</p>
<p>如 &nbsp; &nbsp; byte3 &nbsp;byte2 byte1 &nbsp;byte0</p>
<p>y &nbsp;= &nbsp; &nbsp;y3 &nbsp; &nbsp; &nbsp;y2 &nbsp; &nbsp; &nbsp;y1 &nbsp; &nbsp; &nbsp;y0</p>
<p>那么 y *&nbsp;0x01010101 则实现了 将 y0 y1 y2位和y3位置的累加 则y的值为：</p>
<p>byte3 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;byte2 &nbsp; &nbsp; &nbsp; &nbsp;byte1 &nbsp; &nbsp;byte0</p>
<p>yn &nbsp;= &nbsp; &nbsp; y3+y2+y1+y0 &nbsp; &nbsp; &nbsp; &nbsp;x2 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; x1 &nbsp; &nbsp; &nbsp; &nbsp; x0 &nbsp; &nbsp;将yn &gt;&gt; 24位 则得到了 &nbsp;y3+y2+y1+y0 的效果。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/1q20eov9.html">app上传到App Store的快捷方法及步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/r934mrz8.html">java反射保存</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ep25e9.html">设计模式：单例模式（Singleton）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ope4y9.html">关闭V-Ray warning消息框</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj6l6d9.html">ASP&period;NET MVC轻教程 Step By Step 12&mdash;&mdash;客户端验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdl7l78.html">springboot &plus;spring security4 &plus;thymeleaf 后台管理系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vo1wn8.html">mysqldump   --master-data</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd7jyz8.html">&lbrack;LeetCode&rsqb;&lbrack;Python&rsqb;Palindrome Number</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0ypmgq.html">jquery &plus; ajax调用后台方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg46mr8.html">PHP之输出控制 ob&lowbar;start&lpar;&rpar;，ob&lowbar;get&lowbar;contents&lpar;&rpar;，ob&lowbar;end&lowbar;clean&lpar;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkyygd8.html">hdu&lowbar;1506&colon;Largest Rectangle in a Histogram 【单调栈】</a>
		</li>
						<li><a href="https://www.batexi.com/a/950k7ge8.html">html5中的网页结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4eele9.html">&bsol;r   &bsol;n   &bsol;t   &bsol;n&bsol;t</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1n61pq.html">学习python D1</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e46wvj9.html">利用VS2008编译器编译Qt4&period;8&period;2的MySQL驱动</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jlxo3q.html">requirements&period;txt 的使用与创建</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd1o3v9.html">格式化输出python</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjn4pl9.html">springboot-31-springboot静态注入</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnkjk4q.html">QTime的本质上是一个int，QDateTime本质上是一个qint64</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1xz1x9.html">AdvStringGrid 固定行、列</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/m8zlj03q.html">spring管理bean</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdxzdj8.html">iOS同一项目多个Target的快速实现方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyo5om8.html">apache指定的网络名不再可用</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlxk36q.html">x01&period;os&period;17&colon; 换心术</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qx453z9.html">x01&period;Lab&period;OpenCV&colon; 计算机视觉</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv7k0jq.html">009&period;CentOS 6&period;7安装运行netmap</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7j22kq.html">C&num; FTP 命令无法获取ServerU目录列表问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q26ydw9.html">我所了解的各公司使用的 Ceph 存储集群 &lpar;携程、乐视、有云、宝德云、联通等&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwz44yq.html">SQL Server With 递归 日期 循环</a>
			</li>
						<li><a href="https://www.batexi.com/a/495nywe9.html">ural  Cipher Message</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
